package com.gic.evaluate.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.evaluate.qo.StoreScoreQO;
import com.gic.evaluate.qo.StoreTrendQO;
import com.gic.evaluate.service.EvaluateOverviewApiService;
import com.gic.store.service.StoreWidgetApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-03 9:46
 */
@RestController
public class EvaluateOverviewController {

    @Autowired
    private EvaluateOverviewApiService evaluateOverviewApiService;
    @Autowired
    private StoreWidgetApiService storeWidgetApiService;

    @RequestMapping("/evaluate-chart1")
    public RestResponse evaluateChart1(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<Map<String, Long>> serviceResponse = evaluateOverviewApiService.chart1(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart2")
    public RestResponse evaluateChart2(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<HashMap<String, Map<String, Long>>> serviceResponse = evaluateOverviewApiService.chart2(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart3")
    public RestResponse evaluateChart3(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<Map<String, List<Map<String, Object>>>> serviceResponse = evaluateOverviewApiService.chart3(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-chart4")
    public RestResponse evaluateChart4(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<Map<String, List<Map<String, Object>>>> serviceResponse = evaluateOverviewApiService.chart4(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/evaluate-store-score")
    public RestResponse evaluateStoreScore(StoreScoreQO storeScoreQO) {
        storeScoreQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<Map<String, Object>>> serviceResponse = evaluateOverviewApiService.listStoreScore(storeScoreQO);
        ServiceResponse<Map<String, Object>> totalStoreScore = evaluateOverviewApiService.getTotalStoreScore(storeScoreQO);
        List<Map<String, Object>> result = serviceResponse.getResult().getResult();
        result.add(0, totalStoreScore.getResult());
        return RestResponse.success(serviceResponse);
    }

    @RequestMapping("/evaluate-list-trend")
    public RestResponse evaluateListTrend(StoreTrendQO storeTrendQO) {
        storeTrendQO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<Map<String, Object>>> serviceResponse = evaluateOverviewApiService.listTrend(storeTrendQO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/good-trend-by-date")
    public RestResponse listGoodEvaluateTrendByDate(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<List<Map<String, Integer>>> serviceResponse = evaluateOverviewApiService.listGoodEvaluateTrendByDate(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/bad-trend-by-date")
    public RestResponse listBadEvaluateTrendByDate(String startTime, String endTime, Integer storeWidgetId) {
        List<Integer> storeIdList = Collections.emptyList();
        if (storeWidgetId != null) {
            ServiceResponse<List<Integer>> serviceResponse = storeWidgetApiService.listStoreIdByStoreWidgetId(UserDetailUtils.getUserDetail().getEnterpriseId(), storeWidgetId);
            storeIdList = serviceResponse.getResult();
        }
        ServiceResponse<List<Map<String, Integer>>> serviceResponse = evaluateOverviewApiService.listBadEvaluateTrendByDate(UserDetailUtils.getUserDetail().getEnterpriseId(), startTime, endTime, storeIdList);
        return ResultControllerUtils.commonResult(serviceResponse);
    }
}
